package Lingua::Pere::Misc;

use locale;
use strict;

use vars qw(@ISA $VERSION @EXPORT @EXPORT_OK);

use Exporter;

$VERSION = "0.2.0";
@ISA = qw(Exporter);
@EXPORT = ();
@EXPORT_OK = qw(
	packa
	unpacka
	randval
	dig4bin
	dig4hex
	str2hex
	hex2str
);

use POSIX;
use FindBin;
use Getopt::Long;
use Config::General;
use Pod::Usage;
use Digest::MD5 qw(
	md5
	md5_hex
);

#**************************************************************************
sub packa {
	my ($la, $sq) = @_;

	foreach my $el (@{$sq}) {
		$el = pack($la, $el);
	}

	return $sq;
}
	
#**************************************************************************
sub unpacka {
	my ($la, $sq) = @_;

	foreach my $el (@{$sq}) {
		$el = unpack($la, $el);
	}

	return $sq;
}
	
#**************************************************************************
sub randval {
	my ($sq) = @_;

	if (length($sq) == 4) {
		return $sq;
	} else {
		my @a = unpack("l*", $sq);
		my $i = int(rand(scalar(@a)));
		return pack("l", $a[$i]);
	}
}
	
#******************************************************************
sub dig4bin {
	return Digest::MD5::md5(@_);
}

#******************************************************************
sub dig4hex {
	return Digest::MD5::md5_hex(@_);
}

#******************************************************************
sub str2hex {
	my ($s) = @_;

	my @a = split(//, $s);
	my $h = '';
	map { $h .= sprintf('%02x', ord($_)) } @a;

	return $h;
}

#******************************************************************
sub hex2str {
	my ($h) = @_;

	my $s = '';
	map { $s .= chr(hex($_))} grep { $_ ne '' } split(/(..)/, $h);

	return $s;
}

#**************************************************************************
return 1;
