package Lingua::Pere::Misc::Date;

require 5.000;

use locale;
use strict;

use vars qw(@ISA $VERSION @EXPORT_OK);

use Exporter;

$VERSION = "0.2.0";
@ISA = qw(Exporter);

@EXPORT_OK = qw(
	nowdatea
	nowdate
	nowmonth
	incmonth
	incdate
	decdate
	stripdate
	datedate
);

use POSIX;
use Time::Local;

#**************************************************************************
sub nowdatea {
	my ($tm) = @_;
	$tm = time unless defined $tm;

	my($sec,$min,$hor,$mdy,$mon,$yer) = localtime($tm);

	return ($yer+1900, $mon+1, $mdy, $hor, $min, $sec);
}

#**************************************************************************
sub nowdate {

	return sprintf("%04d-%02d-%02d %02d:%02d:%02d", nowdatea(@_));
}

#**************************************************************************
sub nowmonth {

	my @a = nowdatea(@_);
	return $a[1];
}

#**************************************************************************
sub incmonth {
	my $inc = shift;

	my ($yer, $mon, $mdy, $hor, $min, $sec) = nowdatea(@_);

	$mon += $inc;
	while ($mon > 12) {
		$mon -= 12;
	}

	return sprintf("%04d-%02d-%02d %02d:%02d:%02d", $yer, $mon, $mdy, $hor, $min, $sec);
}

#**************************************************************************
sub incdate {
	my ($inc, $tm) = @_;
	$tm = time unless defined $tm;

	return nowdate($tm+$inc);
}

#**************************************************************************
sub decdate {
	my ($dec, $tm) = @_;
	$tm = time unless defined $tm;

	return nowdate($tm-$dec);
}

#**************************************************************************
sub stripdate {
	my ($date) = @_;
	
	$date =~ s/\.\d+$// if ($date);

	return $date;
}

#**************************************************************************
sub datedate {
	my ($date) = @_;
	
	$date =~ s/\s+.+$// if ($date);

	return $date;
}

#**************************************************************************
return 1;
