package Lingua::Pere::ProgressLine;

use locale;
use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

use Carp;

$VERSION = "0.2.0";
@ISA = qw(Exporter);
@EXPORT = ();
@EXPORT_OK = qw();

use POSIX;

#**************************************************************************
sub new {
	my $proto = shift;
	my $class = ref $proto || $proto;
	
	my ($desc, $bits, $stop) = @_;

	$bits ||= 0;
	my $mask = 2**$bits-1;

	if ($mask > 0) {
		$desc ||= 'Progress';
		printf(STDERR "%s: ", $desc);
	}

	return bless [ 0, $mask, $stop ], $class;
}

#**************************************************************************
sub go {
	my $self = shift;

	if ($self->[1] > 0) {
		if ((++$self->[0] & $self->[1]) == 0) {
			if (defined($self->[2]) && (-f $self->[2])) {
				return 0;
			} else {
				print STDERR "#";
			}
		}
	} else {
		++$self->[0];
		if (defined($self->[2]) && (-f $self->[2])) {
			return 0;
		}
	}
	
	return $self->[0];
}

#**************************************************************************
sub count {
	my $self = shift;

	return $self->[0];
}

#**************************************************************************
sub ok {
	my $self = shift;

	if ($self->[1] > 0) {
		if (defined($self->[2]) && (-f $self->[2])) {
			printf STDERR ">>(%d)<<\n", $self->[0];
			unlink($self->[2]);
			return 0;
		} else {
			print STDERR "#\n";
			return $self->count;
		}
	} else {
		if (defined($self->[2]) && (-f $self->[2])) {
			unlink($self->[2]);
			return 0;
		} else {
			return $self->count;
		}
	}
}

#**************************************************************************
return 1;
__END__
